/*
 * ============================================================================
 * Licensed Materials - Property of IBM
 *  WebSphere sMash
 *
 * (C) Copyright IBM Corp. 2007,2008  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * ============================================================================
 */
if(!dojo._hasResource['zero.ide.controllers.AppUiController']){
dojo._hasResource['zero.ide.controllers.AppUiController'] = true;
dojo.provide('zero.ide.controllers.AppUiController');
dojo.requireLocalization("zero.ide.widget.appmgr", "AppMgrUiNls");

dojo.require('zero.ide.controllers.BaseUiController');
dojo.require('dojox.uuid.generateRandomUuid');

dojo.declare(
    'zero.ide.controllers.AppUiController',
    zero.ide.controllers.BaseUiController,
    {
		admin: true,
        run: function(pDebugged)
        {
           	if(zlog.isDebug())console.debug("in AppUiController run currentApplication = ");
			if(zlog.isDebug())console.debug(currentApplication);

		    var manager = dijit.byId('app-mgr-ui-id')
			var messages = dojo.i18n.getLocalization("zero.ide.widget.appmgr", "AppMgrUiNls");
        	manager._ideWidget.showProgressDlg(dojo.string.substitute(messages.starting_app));

			// Disable the start button
			this.enableRunButton(false);
			
			this.startStopApp = currentApplication;
           	if(zlog.isDebug())console.debug("in AppUiController run set this.startStopApp to  ");
			if(zlog.isDebug())console.debug(this.startStopApp);
			
			// Open Application Console
			var initialView='stderr';
			//ELC Remove console launch
			if (autoShowConsoleWindow) {
			   createWindowConsole(initialView);
			}
	  		var postD = {
				appid: currentApplication.id,  
				debug: pDebugged
			};  

			
	  		var paramsObj = {  
	        	url: '/resources/processes',

	        	sync: false,   
            	// preventCache: true,
		    	load: dojo.hitch(this, 
								 function(response, ioArgs) {
									
									// elc remove call to _appRunningTest since good return here now means it started.
									//this._appRunningTest();
									// elc added lines below since good return here now means it started.
							       this.setStatusRunning(true, true);
				 	               var manager = dijit.byId('app-mgr-ui-id');	
					               manager._ideWidget.hideProgressDlg();
				 				   manager._showAppStatus(this.startStopApp.id, true);
									

									//this.setStatusRunning(true);
									//this.openAppPage();
									return response;
								}),    
            	error: dojo.hitch(this, this._appRunError),	
            	contentType: "application/json",
				mimetype: "application/json",
				//postData: '{ "appid": "' + currentApplication.id + '", "debug": ' + pDebugged + '}',
				postData: dojo.toJson(postD),
            	handleAs: 'text'		
			}		
			dojo.rawXhrPost(paramsObj);
		},	

		_appRunError: function (response, ioArgs) 
		{
           	if(zlog.isDebug())console.debug("in AppUiController _appRunError this.startStopApp is  ");
			if(zlog.isDebug())console.debug(this.startStopApp);

			this.startStopApp.isRunning = false;		
            var manager = dijit.byId('app-mgr-ui-id');	
            //elc removed refresh call- it was causing a problem when called from appEdit: manager.refresh();  					
            manager._ideWidget.hideProgressDlg();
			var messages = dojo.i18n.getLocalization("zero.ide.widget.appmgr", "AppMgrUiNls");
        	var start_app_failed_msg = dojo.string.substitute(messages.start_app_failed);            

	         var portConflictApp = this.findRunningAppWithPort(this.startStopApp.rootUri);
			 if (portConflictApp) {
			 	 var port = this.startStopApp.rootUri.substring(this.startStopApp.rootUri.lastIndexOf(':')+1,this.startStopApp.rootUri.length);
			 	 var port_txt = dojo.string.substitute(messages.port);
			 	 var in_use_txt = dojo.string.substitute(messages.in_use);
			 	 var config_doc_txt = dojo.string.substitute(messages.config_doc);
	             var submsg = start_app_failed_msg +" - " +port_txt+ " "+port+ " " +in_use_txt+ ". " +config_doc_txt;
	             var app_txt = dojo.string.substitute(messages.application);
                 var running_on_port_txt = dojo.string.substitute(messages.running_on_port); 	             
				 var msg = app_txt+ ' "' +portConflictApp.name+ '" ' +running_on_port_txt+ " " +port+ ".";
				 dijit.byId('status-dialog').showDialog('Error', dojo.string.substitute(submsg), msg);
			 } else {
                 dijit.byId('status-dialog').showDialog('Error', dojo.string.substitute(start_app_failed_msg), eval('(' + ioArgs.xhr.responseText + ')').errorMessage);
			 }
            
			if(zlog.isDebug())console.debug("AppUiController._appRunError - App run error: "+eval('(' + ioArgs.xhr.responseText + ')').errorMessage) ;
			manager._showAppStatus(this.startStopApp.id, false);
			
			this.setStatusRunning(false, this.startStopApp.isRunnable);
			return response;
		},	
					
		stop: function()
		{
           	if(zlog.isDebug())console.debug("in AppUiController stop currentApplication = ");
			if(zlog.isDebug())console.debug(currentApplication);

			// Disable the stop button
			this.enableStopButton(false);

		    var manager = dijit.byId('app-mgr-ui-id')
			var messages = dojo.i18n.getLocalization("zero.ide.widget.appmgr", "AppMgrUiNls");		    
		    manager._ideWidget.showProgressDlg(dojo.string.substitute(messages.stopping_app));

			// Disable the stop button
			this.enableStopButton(false);
			
			this.startStopApp = currentApplication;
           	if(zlog.isDebug())console.debug("in AppUiController stop set this.startStopApp to  ");
			if(zlog.isDebug())console.debug(this.startStopApp);
			
	  		var paramsObj = {  
	        	url: '/resources/processes/'+currentApplication.id,
				handleAs: 'text',
		    	load: dojo.hitch(this, 
								 function(response, ioArgs) {
									this._appStopped(ioArgs);
									return response;
								}),     
            	error: dojo.hitch(this, this._appStopError)	
			}		
			dojo.xhrDelete(paramsObj);					
		},

		displayNotRunnableInfo: function()
		{
           	if(zlog.isDebug())console.debug("in AppUiController displayNotRunnableInfo currentApplication = ");
			if(zlog.isDebug())console.debug(currentApplication);
		   	//popup dialog and show the details why application NOT runnable
			 var notRunnableDlg = dijit.byId('app-mgr-notrunnable-ui-id');
             notRunnableDlg.getNotRunnableInfo(currentApplication.id);

		},
		
		_appStopped: function (ioArgs) 
		{			
           	if(zlog.isDebug())console.debug("in AppUiController _appStopped this.startStopApp is  ");
			if(zlog.isDebug())console.debug(this.startStopApp);
            var manager = dijit.byId('app-mgr-ui-id');	
            manager._ideWidget.hideProgressDlg();

			this.setStatusRunning(false, this.startStopApp.isRunnable);

		},
		
		_appStopError: function (response, ioArgs) 
		{
           	if(zlog.isDebug())console.debug("in AppUiController _appStopError this.startStopApp is  ");
			if(zlog.isDebug())console.debug(this.startStopApp);

			// Enable the stop button
			this.enableStopButton(true);
			this.enableRunButton(false);

            var manager = dijit.byId('app-mgr-ui-id');	
            //elc removed refresh call- it was causing a problem when called from appEdit: manager.refresh();  					
            manager._ideWidget.hideProgressDlg();

			alert("App stop error: "+ioArgs.xhr.status);
			
			return response;
		},	
			
		setStatusRunning: function(bRunning, bRunnable) {	
           	if(zlog.isDebug())console.debug("in AppUiController setStatusRunning this.startStopApp is  ");
			if(zlog.isDebug())console.debug(this.startStopApp);
						
	
			if (this.startStopApp.isRunning !== bRunning) {
				this.showAppStatus(this.startStopApp.id, bRunning);
			}
			
			this.startStopApp.isRunning = bRunning;
            this.startStopApp.isRunnable = bRunnable;

						
			if (bRunning) {
				this.enableStopButton(true);
				this.enableRunButton(false);
				this.setNotRunnableButton(false);
   		        //show appRootURI as a link; user can click on link to bring up the app
                if (!this.admin) {     
			       dojo.byId('appRootUriLink').innerHTML = this.startStopApp.rootUri;								
                }
				
				//No longer showing status --- Show the status text		
				/* dojo.byId('statusStopped').style.display = 'none';		
				dojo.byId('statusNotRunnable').style.display = 'none';				
				dojo.byId('statusRunning').style.display = 'none'; */								
			}
			else if (this.startStopApp.isRunnable) {
				
				this.enableStopButton(false);
				this.enableRunButton(true);
				this.setNotRunnableButton(false);
			    
				//show rootUri as normal text, displays URL for this app
                if (!this.admin) {     
			       dojo.byId('appRootUriText').innerHTML = this.startStopApp.rootUri;								
                }

				//No longer showing status --- Show the status text		
				/*dojo.byId('statusRunning').style.display = 'none';
				dojo.byId('statusNotRunnable').style.display = 'none';				
				dojo.byId('statusStopped').style.display = 'inline'; */				
			} else {
				//app is NOT runnable 
				this.enableStopButton(false);
				this.enableRunButton(false);
				this.setNotRunnableButton(true);//show not runnable button - 'grayed out'
				
				//set text as normal but mention this app can not run 
                if (!this.admin) {     
			       dojo.byId('appRootUriText').innerHTML = "";//not used
                   var messages = dojo.i18n.getLocalization("zero.ide.widget.appmgr", "AppMgrUiNls");
			       dojo.byId('notRunnableLink').innerHTML = dojo.string.substitute(messages.not_runnable);								
                }

				//No longer showing statis --- Show the status text		
				/*dojo.byId('statusRunning').style.display = 'none';
				dojo.byId('statusStopped').style.display = 'none';
				dojo.byId('statusNotRunnable').style.display = 'inline';*/				
			}

		},
		
		setStatusHidden: function() {
			//No longer showing status 		
			/*dojo.byId('statusRunning').style.display = 'none';
			dojo.byId('statusStopped').style.display = 'none';*/
		},	
		
		enableRunButton: function( enabled ) {	
            if (!this.admin) {     
			    dojo.byId('runButtonEnabled').style.display = (enabled) ? 'inline' : 'none';								
            }
		},
					
		enableStopButton: function( enabled ) {	
            if (!this.admin) {     
			   dojo.byId('stopButtonEnabled').style.display = (enabled) ? 'inline' : 'none';								
			   dojo.byId('appLinkButtonEnabled').style.display = (enabled) ? 'inline' : 'none';								
			   dojo.byId('appLinkButtonDisabled').style.display = (enabled) ? 'none' : 'inline';
            }
		},

		setNotRunnableButton: function( show ) {
            if (!this.admin) {     	
			    dojo.byId('notRunnableButton').style.display = (show) ? 'inline' : 'none';								
            }
		},
					
		openAppPage: function()
		{
	  		var paramsObj = {  
	        	url: '/resources/applications/'+currentApplication.id,
		    	load: dojo.hitch(this, 
								 function(response, ioArgs) {
									this.openBrowserPage(response, ioArgs);
									return response;
								}),     
            	error: dojo.hitch(this, this._appOpenPageError),
				 preventCache: true,
				 handleAs: "text"					 
			}		
			dojo.xhrGet(paramsObj);					
		},


		openBrowserPage: function (response, ioArgs) 
		{
			var jsonResult = eval('('+response+')');
			if(zlog.isDebug())console.debug("openBrowserPage: response ");
			if(zlog.isDebug())console.debug(jsonResult);
            var appUri = jsonResult.rootUri;
			if(zlog.isDebug())console.debug("openBrowserPage: appUri =  "+appUri);
		    window.open (appUri, '_blank');
			return false;
		},	

		_appOpenPageError: function (response, ioArgs) 
		{
			alert("App Open Page error: "+ioArgs.xhr.status);
			return response;
		},	

		
		updateApplicationStatus: function () {
            if(zlog.isDebug())console.debug("in AppUicontroller.updateApplicationStatus ");
            this.startStopApp = currentApplication;			
           	if(zlog.isDebug())console.debug("in AppUiController updateApplicationStatus currentApplication = ");
			if(zlog.isDebug())console.debug(currentApplication);
           	if(zlog.isDebug())console.debug("in AppUiController updateApplicationStatus set this.startStopApp to  ");
			if(zlog.isDebug())console.debug(this.startStopApp);

            dojo.xhrGet({url: '/resources/applications/'+currentApplication.id,
                     load: dojo.hitch(this, 
					 				   function(response, ioArgs) {
									   	   //this.setStatusRunning(true);
                                           var jsonResult = eval('('+response+')');
										   this.setStatusRunning(jsonResult.isRunning, jsonResult.isRunnable);
										   return response;
									   }),								
                     error: dojo.hitch(this, 
                                       function(response, ioArgs)
                                       {    
									   	if (ioArgs.xhr.status != 404) {
                                            var messages = dojo.i18n.getLocalization("zero.ide.widget.appmgr", "AppMgrUiNls");									   	
											alert(dojo.string.substitute(messages.error_app_status));
										}    
										else
										{
											this.setStatusRunning(false, this.startStopApp.isRunnable);											
                                        }
										return response;
										}),
					preventCache: true,
					handleAs: "text"
                    });
		},			

        _checkApplication: function()
        {
            return '';
        },
        
        _updateApplicationFromIde: function()
        {
            this._application.name = this._ideWidget.getApplicationName();			
            this._application.description = this._ideWidget.getApplicationDescription();
			this._application.id = this._ideWidget.getApplicationId();
        },

        _updateIdeFromApplication: function()
        {
			this._ideWidget.setApplicationId(this._application.id);			
            this._ideWidget.setApplicationDescription(this._application.description);				
        }
    }
);
}