/*
 * ============================================================================
 * Licensed Materials - Property of IBM
 *  WebSphere sMash
 *
 * (C) Copyright IBM Corp. 2007,2008  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * ============================================================================
 */
if(!dojo._hasResource['zero.ide.controllers.BaseUiController']){
dojo._hasResource['zero.ide.controllers.BaseUiController'] = true;
dojo.provide('zero.ide.controllers.BaseUiController');
dojo.requireLocalization("zero.ide.widget.appmgr", "AppMgrUiNls");

dojo.require('dojox.data.dom');
dojo.require('dojox.uuid.generateRandomUuid');

dojo.declare(
    'zero.ide.controllers.BaseUiController',
    null,
    {
        _commandState: null,
        _creatingApplication: false,
        _initialized: false,
        progressDlg: null,
        _application: {id: ''},
        _statics:
        {
            // CMD_STATE_PUBLISH: 'publish',
            CMD_STATE_REMOVE: 'remove'
            // CMD_STATE_SAVE: 'save'
            // CMD_STATE_SAVE_AFTER_PUBLISH: 'save-after-publish',
            // CMD_STATE_UNPUBLISH: 'unpublish',
            // PUBLISH_APPLICATION_REQUEST_ID: 'publish-application',
            // UNPUBLISH_APPLICATION_REQUEST_ID: 'unpublish-application'
        },
        
        open: function(pApplication, pCreateUid)
        {
			if(zlog.isDebug())console.debug("in BaseUiController open pApplication =")
			if(zlog.isDebug())console.debug(pApplication);
			if(zlog.isDebug())console.debug(pCreateUid);
            this._ideWidget.clear();
            if (undefined != pApplication)
            {			
                if (typeof(pApplication) == 'string')
                {
                    // Used in import
                }
                else
                {
                    this._application = pApplication;
                }
                this._updateIdeFromApplication();

				currentApplication = this._application;
				if(zlog.isDebug())console.debug("in BaseUIController open setting currentApplication to ");
                if(zlog.isDebug())console.debug(currentApplication);

                this._finishOpen(true);
				 
                if(zlog.isDebug())console.debug("in base-controller app open");
                if(zlog.isDebug())console.debug(this._application);  
				var xid = this._application.id;
				if (!xid) {
					xid = this._application.Id;
				} 
                if(zlog.isDebug())console.debug("xid = "+xid);  
                var uiview = this._application.uiview;
				if (!uiview) {
					uiview = "allFilesView"; //default view
				} 
				

                if(!this.handleInitParms && !indexRestoringState) {
				   var historyTracker = new HistoryTracker('AppEditor',xid, uiview, this._application.file, this._application.name);
                   dojo.back.addToHistory(historyTracker);
                } else {
	   			   this.handleInitParms = null;
				}

                this.applicationLoaded(this._application);
            }
            else
            {
                this._finishOpen(false);
				currentApplication = null;
            }
        },

        findAppById: function(pId)
        {
			if(zlog.isDebug())console.debug("in BaseUIController findAppById pId ="+pId);
			if(zlog.isDebug())console.debug(this.currentApps);
            foundApp = null;
			if (this.currentApps && this.currentApps.length > 0) {
				for (var i=0  ;  i < this.currentApps.length  ;  i++) {
					if (pId == this.currentApps[i].id) {
						foundApp = this.currentApps[i];
						break;
					}
				}
			}
			return foundApp;
			
        },


        findRunningAppWithPort: function(pRootUri)
        {
			if(zlog.isDebug())console.debug("in BaseUIController findRunningAppWithPort pRootUri ="+pRootUri);
			if(zlog.isDebug())console.debug(this.currentApps);
            foundApp = null;
			if (this.currentApps && this.currentApps.length > 0) {
				for (var i=0  ;  i < this.currentApps.length  ;  i++) {
					if (this.currentApps[i].isRunning && pRootUri == this.currentApps[i].rootUri) {
						foundApp = this.currentApps[i];
						break;
					}
				}
			}
			return foundApp;
			
        },

        
        findAndOpenApp: function(handleInitParms)
        {
			if(zlog.isDebug())console.debug("in BaseUIController findAndOpenApp handleInitParms =")
			if(zlog.isDebug())console.debug(handleInitParms);
			this.handleInitParms = handleInitParms;
			var url = '/resources/applications/'+handleInitParms._app;
            dojo.xhrGet({url: url,
                     load: dojo.hitch(this, this._applicationToOpenFound),
                     error: dojo.hitch(this, 
                                       function(response, ioArgs)
                                       {
                                            var messages = dojo.i18n.getLocalization("zero.ide.widget.appmgr", "AppMgrUiNls");
									   	    if (this._statusDialog) {
                                              this._statusDialog.showDialog('Error', '',
                                                                          dojo.string.substitute(messages.error_fetching_app_id)+ " " +handleInitParms._app);
                                            } else {
												alert(dojo.string.substitute(messages.error_fetching_app_id)+ " " +handleInitParms._app)
											}																		  
											return response;																		  
                                       }),                  
					 preventCache: true,
					 handleAs: "text"					 
                    });

        },

        
        _applicationToOpenFound: function(pResponse, pIoArgs)
        {          
            var jsonResult = eval('('+pResponse+')');

			if(zlog.isDebug())console.debug("in BaseUIController _applicationToOpenFound jsonResult =")
			if(zlog.isDebug())console.debug(jsonResult);
			var el = "http://localhost:8070/"+this.handleInitParms._app;
			var app = {
				id: this.handleInitParms._app,
				description: jsonResult.description,
				editLink: el,
				modulegroup: jsonResult.modulegroup,
				rootUri: jsonResult.rootUri,
				isRunning: jsonResult.isRunning, 
				isRunnable: jsonResult.isRunnable,
				name: jsonResult.name,
				path: jsonResult.path,
				theme: "human-theme",
				uiview: this.handleInitParms._uiview,
				file: this.handleInitParms._file
			}
			var pub = this.handleInitParms;
			//this.handleInitParms = null;
			
			currentApplication = app;
			
			var title = "Zero Admin";
			   if (app.name !== null && app.name !== undefined) {
		             title = "App: "+app.name+" - "+title;
		       }
			   if (app.file !== null && app.file !== undefined) {
		          title = "File: "+app.file+" - "+title;
		       } else {
 			      if (app.uiview !== null && app.uiview !== undefined) {
		             title = app.uiview+" - "+title;
		          }
			   	  
			   }

			
            // elc removed this to get back to work when a file was edited     this.open(app);   
			// need to go to the right page...
            dojo.publish("ShowView", [{source: pub }]);
			this.updateApplicationStatus();


        },


        
        _finishOpen: function(pOpenDialog)
        {          
            this._ideWidget.open(pOpenDialog);
        },
        
        remove: function(pApplicationId)
        {
            
        },
        

        retrieveAll: function()
        {
            //ELC TRY To remove the Loading applications msg for now, may want to add it back if we know when dirty.
			//this._ideWidget.showProgressDlg('Loading applications');
            
            //ELC this should change to use url: '/resources/applications' I think  
            dojo.xhrGet({url: '/resources/applications',
                     load: dojo.hitch(this, this._applicationReadFinished),
                     error: dojo.hitch(this, 
                                       function(response, ioArgs)
                                       {														  
										  return response;																		  
                                       }),                  
					 preventCache: true,
					 handleAs: "text"					 
                    });
        },		


        _applicationReadFinished: function(pResponse, pIoArgs)
        {            
            var jsonResult = eval('('+pResponse+')');
			if(zlog.isDebug())console.debug("in _applicationReadFinished - jsonResult =");
			if(zlog.isDebug())console.debug(jsonResult);
	
            var applications = [];
			applications = jsonResult;
/*            for (var id in jsonResult)
            {			
				var entry = jsonResult[id];
				var desc = entry.description;
				//if(zlog.isDebug())console.debug(desc);
				if (null === desc || undefined === desc || desc == "") {
					//desc = "Default Description";
					desc = "";
				}
				var mg = entry.modulegroup;
				if (null === mg || undefined === mg || mg == "") {
					mg = "Undefined";
				}

                applications.push({
                    id: entry.id,
                    name: entry.name,
                    description: desc,
					modulegroup: mg,
					rootUri: entry.rootUri,
                    //theme: 'human-theme',
                    isRunning: entry.isRunning,
				    isRunnable: entry.isRunnable,
                    canDebug: entry.canDebug,
                    //editLink: 'http://localhost:8070/'+jsonResult[id],
					path: entry.path
                });
			}
			// Load the filter table
*/
            this.applicationsRead(applications);
			
			this.currentApps = applications;
			//ELC TRY To remove the Loading applications msg for now, may want to add it back if we know when dirty.
            //this._ideWidget.hideProgressDlg();

            if (!this._initialized) {
			   this._initialized=true;
			   this._initializeTaskScheduler();
			}

			return pResponse;
        },	

        _handleUpdateStatus: function(pResponse, pIoArgs)
        {            
            var jsonResult = eval('('+pResponse+')');
			if(zlog.isDebug())console.debug("BaseUiController in _handleUpdateStatus - jsonResult =");
			if(zlog.isDebug())console.debug(jsonResult);
			
            if (null !== currentApplication && undefined !== currentApplication) {
			    if(zlog.isDebug())console.debug("in _handleUpdateStatus - running1 ="+jsonResult.isRunning);

			    //update the rootUri from the callBack
			    currentApplication.rootUri = jsonResult.rootUri;
				    
			    this.saveAppStatus(currentApplication.id, jsonResult.isRunning);
		        this.startStopApp = currentApplication;
				this.setStatusRunning(jsonResult.isRunning, jsonResult.isRunnable,jsonResult.rootUri);
			} else {
				if (jsonResult.length !== this.currentApps.length
                    || this.checkAppListDirty(jsonResult)) {  
                    this.applicationsRead(jsonResult);  // handle apps added or removed from list
                } else {  // just update current entries
		            for (var id in jsonResult)
		            {			
						var entry = jsonResult[id];
					    this.saveAppStatus(entry.id, entry.isRunning);						 
						//this.showAppStatus(entry.id, entry.isRunning);
						this.updateAppInfo(entry.id, entry);
					}
				}
			}
			return pResponse;
        },	
  
    checkAppListDirty: function(pApplications)
    {
        var dirty = false;
        if (pApplications.length !== 0) {
                 for (var i = 0; i < pApplications.length; i++) {
                  var idFound = false;
                   for (var j = 0; j < this.currentApps.length; j++) {
                    if (pApplications[i].id == this.currentApps[j].id) {
                        idFound = true;
                        break;
                    }
                } 
                if (!idFound) {
                   return true;
                }
                 }
        }
        return false;
    },  
  
		_initializeTaskScheduler: function () {
            var properties = {
								url:            "/ping.html",
								callbackStopped: dojo.hitch(this,"_setServerStopped"),
								callbackRunning: dojo.hitch(this,"_setServerRunning")
	   						 };
	   		if (typeof abSettings != "undefined") {				 
   				ABCom.init(properties,abSettings["ping"]);
   			}
   			else {
   				ABCom.init(properties,true);
   			}
   			
   			ABCom.schedule(
   			    "ApplicationStatus",
                dojo.xhrGet,
                {
                  url:  "",
                  load: dojo.hitch(this,
                                   function(response, ioargs) {
                                   	  this._handleUpdateStatus(response, ioargs);
                                      return response;
                                   }),
                  error: dojo.hitch(this,
                                   function(response, ioargs) {
                                      return response;
                                   }),
                  handleAs: "text"
                },
                18000,               // it was 24000
                dojo.hitch(this, 
                      function () {
               			var url = '/resources/applications';
						if (null !== currentApplication) {
							url = url +'/'+ currentApplication.id;
						}
						return url;
                      })
                 );
         },			
 
        _setServerStopped: function() {
			   if (this.progressDlg === null) {
	               this.progressDlg = this._ideWidget;
                   var messages = dojo.i18n.getLocalization("zero.ide.widget.appmgr", "AppMgrUiNls");
	               this.progressDlg.showProgressDlg(dojo.string.substitute(messages.server_not_responding));
			   }
		},
		 
        _setServerRunning: function() {
		  		   this.progressDlg.hideProgressDlg();
                   this.progressDlg = null;
		},				
        
		saveAppStatus: function(appId, running) 
		{
  		    if (this.currentApps && this.currentApps.length > 0) {
				for (var i=0  ;  i < this.currentApps.length  ;  i++) {
                  if(this.currentApps[i].id == appId) { 
                      this.currentApps[i].isRunning=running;
				  }
				}
			}			
		},       
        
        setIdeWidget: function(pWidget)
        {
            this._ideWidget = pWidget;
            pWidget.setController(this);
        },
		
        doShowCreateFileDialog: function(pWidget)
        {
        },
        
        // Functions that need to implemented in the subclass
        run: function(pVersion, pApplicationId) {},
        _checkApplication: function() {return '';},
        _getApplicationClass: function() {return null;},
        _updateApplicationFromIde: function() {},
        _updateIdeFromApplication: function() {},
        
        // Dojo Event stubs
        applicationCreated: function(pApplication) {},
        applicationLoaded: function(pApplication) {},
        //applicationPublished: function(pApplication) {},
        applicationRemoved: function(pApplication) {},
        applicationUpdated: function(pApplication) {},
        applicationsRead: function(pApplications) {}
    }
);
}