/*
 * ============================================================================
 * Licensed Materials - Property of IBM
 *  WebSphere sMash
 *
 * (C) Copyright IBM Corp. 2007,2008  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * ============================================================================
 */
        /* Copyright (c) 2008 by IBM Corporation */

if(!dojo._hasResource["zero.ide.widget.appmgr.BrowseApplicationsDialog"]){
dojo._hasResource["zero.ide.widget.appmgr.BrowseApplicationsDialog"] = true;
dojo.provide("zero.ide.widget.appmgr.BrowseApplicationsDialog");

dojo.require('zero.ide.data.ideFilePathStore');

dojo.require("dijit.Dialog");
dojo.require("dijit.form.Button");
dojo.require("dijit.form.Textarea");
dojo.require("dijit.form.TextBox");
dojo.require("dijit.form.ComboBox");
dojo.require("dijit.form.FilteringSelect");
dojo.require('dijit.Tooltip');
dojo.require('dijit._Templated');
dojo.require('dijit._Widget');
dojo.require("dojox.uuid.generateRandomUuid");

dojo.requireLocalization("zero.ide.widget.appmgr", "CommonAppDialogNls");

dojo.declare("zero.ide.widget.appmgr.BrowseApplicationsDialog",
             [dijit._Widget, dijit._Templated],
{
    widgetsInTemplate: true,
    templatePath: dojo.moduleUrl("zero","ide/widget/appmgr/templates/BrowseApplicationsDialog.html"),
	messages: null,
    needRefresh: false,
	

    setUpCreate: function()
    {
		if(zlog.isDebug())console.debug("in BrowseApplicationsDialog.setUpCreate")

		this.myButton = this.openButton;


		//this.resourceString = this.baseResourceString +"/1/files";
		this.resourceString = "";		
		        
		var _url = 'resources/filelist?metadata&flat&nofiles&root='+userSettings.defaultPath;
		
        if (!this.filePathCombo) {
		
			this.filePathStore = new zero.ide.data.ideFilePathStore({
				url: _url,
				resourceString: this.resourceString
			});
			this.filePathCombo = new dijit.form.FilteringSelect({
				id: "fileSelectPathCombo",
				autoComplete: false,
				store: this.filePathStore,
				searchAttr: "path",
				hasDownArrow: false,
				//pageSize:10
				searchDelay: 200
			
			}, dojo.byId("fileSelectPathCombo"));
			//this.theDialog.closeButtonNode.style.width = '440px';
			dojo.style(this.filePathCombo.domNode, "width", "45em");
			
			dojo.addClass(this.filePathCombo, "filePathCombo");
			
			this.setPath(userSettings.defaultPath);
			
			this._setUpConnections(); 	   		   
			this.openButton.setDisabled(this.filePathCombo.textbox.value.length == 0);
		}
		else {
			this.setPath(userSettings.defaultPath);
		}		   
	   //if(zlog.isDebug())console.debug("~setUpCreate");
    },

		_setUpConnections: function() {
		   this.filePathKeyConnection = dojo.connect(this.filePathCombo, 'onKeyDown', this, 'checkForEnter');		   
		   this.filePathChangeConnection = dojo.connect(this.filePathCombo, 'onChange', this, '_filePathChangedThroughSelection');		   
           this.filePathKeyUpConnection =  dojo.connect(this.filePathCombo, 'onKeyUp',this, '_filePathChanged');
		},

	
	
	setPath: function(queryPath, displayPath) {
		if(zlog.isDebug())console.debug("setPath:"+queryPath);
		if(zlog.isDebug())console.debug("displayPath:"+displayPath);

		if (!displayPath) {
			displayPath = queryPath;
		}
		
		this.directoryDepth = this._computeDirectoryDepth(queryPath);
		if (queryPath[queryPath.length-1] != userSettings.fileSeparator) {
			queryPath = queryPath.substring(0, queryPath.lastIndexOf(userSettings.fileSeparator)+1);
		}		
		var _url = 'resources/filelist?metadata&flat&nofiles&root='+queryPath;
        this.filePathStore.setUrl(_url, this.resourceString);

		this.filePathCombo.attr('displayedValue', displayPath); //gxr setDisplayedValue(displayPath);
        this._startSearch(displayPath);
		if(zlog.isDebug())console.debug("~setPath");				
	},
	
	_startSearch: function(displayPath) {	
						
		displayPath = displayPath.replace(/\\/g,"\\\\");//fixes highlighting	
		this.filePathCombo._startSearch(displayPath);
	},

    destroy: function() 
	{
		if(zlog.isDebug())console.debug("destroy");
		dojo.disconnect(this.filePathKeyConnection);
		dojo.disconnect(this.filePathChangeConnection);
		dojo.disconnect(this.filePathKeyUpConnection);
		return this.inherited('destroy',arguments);	
	},

    show: function()
    {		
        //this.filePath.setValue('');
		//this.filePathCombo.setDisplayedValue('');

        //this._appThemeSelectionChanged();

        this.theDialog.show();
        this.theDialog.closeButtonNode.style.display = '';        
        
        // set timeout to allow the browser to render dialog
        setTimeout(dojo.hitch(this, function() {
			    this.filePathCombo.textbox.focus();
            }), 200);
    },
    
	hide: function() {
        this.theDialog.hide();
        //this.dialogClosed();
	},

    _filePathChangedThroughSelection: function(pEvent)
    {
//		if(zlog.isDebug())console.debug("onChange:");
//		if(zlog.isDebug())console.debug(pEvent);
		var value = pEvent;
		if (value) {
			this.openButton.setDisabled(value.length == 0);
			this._setPathIfNeeded(value);
		}	
//		if(zlog.isLog())console.log("~onChange");	
	},

    _filePathChanged: function(pEvent)
    {
		if(zlog.isDebug())console.debug("_filePathChanged");		
		//if(zlog.isDebug())console.debug(pEvent);
	
		var value = pEvent.target.value;
        
		this.filePathCombo.highlightMatch = "first";
		this.filePathCombo.autoComplete = false;		
		if (value[value.length - 1] == userSettings.fileSeparator) {
		   if(zlog.isDebug())console.debug("in _filePathChanged setting highlightMatch to none");
		   this.filePathCombo.autoComplete = true;
		   if (!this.filePathCombo._isShowingNow) {
		       this.filePathCombo.highlightMatch = "none";
		   }		
		}
		
		if ((pEvent.keyCode == dojo.keys.BACKSPACE) || (pEvent.keyCode == dojo.keys.DELETE))
		{		
				// As the user is backing up or deleting, they may have removed a file separator,
				// which means we need to repopulate the combobox			
				var numSeparators = this._computeDirectoryDepth(value);
				//this.setPath(value);				
				if (numSeparators != this.directoryDepth) {				
					// We need to refresh the list based on the last known directory
		            if(zlog.isDebug())console.debug("_filePathChanged - in if");		
					this.setPath(value.substring(0, value.lastIndexOf(userSettings.fileSeparator)+1), value);
				}			
				else {
					if(zlog.isDebug())console.debug("in _filePathChanged else value= "+value);		
					//this.filePathCombo.setValue(value);
			        //var escapedValueOne = value.replace(/\\\\/g,"\\");	
			        //var escapedValue = escapedValueOne.replace(/\\/g,"\\\\");
					//this.setPath(escapedValueOne);
					this.setPath(value);				
				}
									
		}		
		else {
		    if(zlog.isDebug())console.debug("in _filePathChanged else2 value= "+value);		

			// Only update the combobox if the path is empty or the cursor is at the end 
			// and is a separator				
			if ((!value || value.length == 0) ||
			((value[value.length - 1] == userSettings.fileSeparator) &&
			(this.filePathCombo._getCaretPos(this.filePathCombo.focusNode) == value.length))) {
				this._setPathIfNeeded(value);
			}
			else {
			
				// Only update the combobox if the path is empty or the cursor is at the end 
				// and is a separator				
				if ((pEvent.keyCode !== dojo.keys.UP_ARROW) && (pEvent.keyCode !== dojo.keys.DOWN_ARROW) &&
				(pEvent.keyCode !== dojo.keys.ENTER) &&
				(pEvent.keyCode !== dojo.keys.ESCAPE) &&
				(pEvent.keyCode !== dojo.keys.TAB)) {
				
					if ((!value || value.length == 0) ||
					((value !== this.filePathCombo._lastValue)))  // &&
					{
				        this.setPath(value);
					}
				}
			}				

		}	
		if ((this.filePathCombo.textbox.value.length == 0) || (!this.filePathCombo.isValid())) {
			this.openButton.setDisabled(true);
		}
		else {
			this.openButton.setDisabled(false);
		}
		if(zlog.isDebug())console.debug("~_filePathChanged");		
	},
	
	_setPathIfNeeded: function (value)
	{	
		// Don't set the path if we don't have focus
		if (!this.filePathCombo._focused)
			return;	
		// If we are at a different directory level, we need to refresh the path list from the server		
		var numSeparators = this._computeDirectoryDepth(value);
		if (numSeparators != this.directoryDepth) {				
			// We need to refresh the list
			var unEscapedValue = value.replace(/\\\\/g,"\\");	
			this.setPath(unEscapedValue);
		}			       
    },
	
	_computeDirectoryDepth: function(path) {
		var numSeparators = 0;
		if ((path != null) && (path.length>0)) {				
			numSeparators = path.split(userSettings.fileSeparator).length-1;
//			if(zlog.isLog())console.log("#separators ="+numSeparators);
//			if(zlog.isLog())console.log("directoryDepth="+this.directoryDepth);
		}			
		return numSeparators;
	},
	
    checkForEnter: function(pEvent)
    {
	    //if(zlog.isDebug())console.debug("checkForEnter pEvent.key : " + pEvent.key  + "pEvent.charCode ="+pEvent.charCode);
        if (pEvent.keyCode == dojo.keys.ENTER  &&
               this.filePathCombo.getValue().length != 0 && 
			   !this.filePathCombo._isShowingNow && this.filePathCombo._isvalid)
        {
            //dojo.stopEvent(pEvent);
			this._fileSelected(pEvent);			           
        }
    },

	dialogReady: function() {
	  return  !(this.filePathCombo.textbox.value.length == 0) || (!this.filePathCombo.isValid());
	},
    
    
    postMixInProperties: function()
    {
        zero.ide.widget.appmgr.BrowseApplicationsDialog.superclass.postMixInProperties.apply(this, arguments);

		this.messages = dojo.i18n.getLocalization("zero.ide.widget.appmgr", "CommonAppDialogNls", this.lang);
        
        this._uid = dojox.uuid.generateRandomUuid();
    }, 
	
	
	_fileSelected: function (data) 
	{		
		//if(zlog.isDebug())console.debug("in _fileSelected");	
	},	
	    
    // Dojo event stubs
    dialogClosed: function() {},

    // Dojo attach Points
	filePathKeyConnection : null,
	filePathChangeConnection: null,
    fileName: null,
    filePath: null,
	selectedFileUrl: null,
	appName: null,
    openButton: null,
//	openTitle:"Browse Applications",
	resourceString: "/resources/filelist",
	baseResourceString: "/resources/filelist",
    theDialog: null,
	directoryDepth: 0
}
);
}