/*
 * ============================================================================
 * Licensed Materials - Property of IBM
 *  WebSphere sMash
 *
 * (C) Copyright IBM Corp. 2007,2008  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * ============================================================================
 */
        /* Copyright (c) 2007 by IBM Corporation */

if(!dojo._hasResource["zero.ide.widget.environment.StatusDialog"]){
dojo._hasResource["zero.ide.widget.environment.StatusDialog"] = true;
dojo.provide("zero.ide.widget.environment.StatusDialog");

dojo.require('dijit.Dialog');
dojo.require('dijit.form.Button');
dojo.require('dijit._Templated');
dojo.require('dijit._Widget');
dojo.require('dojox.uuid.generateRandomUuid');

dojo.declare("zero.ide.widget.environment.StatusDialog",
             [dijit._Widget, dijit._Templated],
{
    widgetsInTemplate: true,
    
    templateString:
    ['<div>',
        '<div dojoType="dijit.Dialog" dojoAttachPoint="dialog"',
              'duration="1" style="margin: 0px;">',
            '<div class="freedom-form-box">',
                '<div class="freedom-form">',
                    '<ul class="freedom-form-list">',
                        '<li style="padding-bottom: 5px; margin-left: 0.5em;">',
                            '<label for="${_uid}-msg" style="display: block;"',
                                    'dojoAttachPoint="subTitle">',
                            '</label>',
                            '<div id="${_uid}-msg" dojoAttachPoint="message">',
                            '</div>',
                        '</li>',
                        '<li style="padding-top: 3px; margin-left: 0.5em;">',
                            '<button dojoType="dijit.form.Button" type="submit"',
                                     'dojoAttachEvent="onClick:okClicked" tabIndex="0" dojoAttachPoint="okButton">',
                                '<b>OK</b>',
                            '</button>',
                        '</li>',
                    '</ul>',
                '</div>',
            '</div>',
        '</div>',
     '</div>'
    ].join(' '),
    
    _context: null,
    _timeoutHandle: null,
    
    showDialog: function(pTitle, pSubTitle, pMessage, pTimer)
    {
        this.dialog.titleNode.innerHTML = pTitle;
        this.subTitle.innerHTML = pSubTitle;
        this.message.innerHTML = pMessage;
        this.dialog.show();
        if (undefined !== pTimer  &&  0 != pTimer)
        {
            this._timeoutHandle = setTimeout(this._timeoutCallback,
                                             pTimer * 1000);
        }
        // set timeout to allow the browser to render dialog
        setTimeout(dojo.hitch(this, function() {
			this.okButton.focus();
          }), 600);

    },
    
    hideDialog: function()
    {
        this.dialog.hide();
    },
    
    setCallback: function(pContext, pFunction)
    {
        this._context = pContext;
        this._function = pFunction;
    },
    
    okClicked: function()
    {
        if (this._timeoutHandle != null)
        {
            clearTimeout(this._timeoutHandle);
            this._timeoutHandle = null;
        }
        this.hideDialog();
        var context = this._context;
        this._context = null;
        if (null != context)
        {
            setTimeout(dojo.hitch(context, this._function), 20);
        }
    },
    
    postMixInProperties: function()
    {
        zero.ide.widget.environment.StatusDialog.superclass.postMixInProperties.apply(this, arguments);
        
        this._uid = dojox.uuid.generateRandomUuid();
        this._timeoutCallback = dojo.hitch(this, this.okClicked);
    },
    
    // Dojo Attach Points
    statusDialog: null,
    statusMessage: null
});
}